#define Create_0
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// init

/* motion variables */
xsp = 0;
ysp = 0;
jhold = 0;
onground = 0;

/* various player states */
facing = 1;
running = 0;
casting = 0;
cast_success = 0;
anim_frame = 0;
computering = 0;
computer_selection = 0;
climbing = 0;
keys = 0;
spellpath_length = 0;
max_spellpath_length = 370;

/* spellcasting things */
cards = ds_list_create();
spellpath_x = ds_list_create();
spellpath_y = ds_list_create();
colors[0] = c_white;
colors[1] = c_red;
colors[2] = c_yellow;
colors[3] = c_lime;
colors[4] = c_aqua;
colors[5] = c_blue;
colors[6] = c_fuchsia;
cardnames[0] = "REMOVE CARD";
cardnames[1] = "FLAMES     ";
cardnames[2] = "LIGHTNING  ";
cardnames[3] = "FLOWER     ";
cardnames[4] = "FREEZE     ";
cardnames[5] = "BUBBLE     ";
cardnames[6] = "TELEKINESIS";

/* strange room reloading system
loadlist_x = ds_list_create();
loadlist_y = ds_list_create();
loadlist_o = ds_list_create();
*/

/* mysterious */
view_yview[1] = HUD_YOFFSET;
computer_font = font_add_sprite(spr_computerfont, ord('0'), 0, 0);
x_before_telekinesis = x;
y_before_telekinesis = y;
alarm[0] = 1;
delta_xview = 0;
delta_yview = 0;
event_inherited();
/* repeat 12 ds_list_add(cards, irandom_range(1, 6)); */
#define Destroy_0
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// things for handling death / end of level
sound_volume(sound_play("snd_playerdestroy"), 2);
var deathtext;
deathtext = instance_create(0, 0, obj_wavytext);
deathtext.textstring = "Press R to restart";
deathtext.textcolor = c_yellow;
deathtext.alarm[0] = 0;
#define Alarm_0
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// deactivate most things outside view
instance_deactivate_object(obj_wall);
with (obj_spinnysquare) { /* absolutely unbelievable. */
    x = xstart;
    y = ystart;
}
instance_deactivate_object(par_hazard);
instance_deactivate_object(par_entity); /* somehow this doesnt deactivate the player? not gonna question it since it works */
instance_activate_region(view_xview[0] - 16, view_yview[0] - 16, view_wview[0] + 32, view_hview[0] + 32, 1);

/* signal the tree placer */
if instance_exists(obj_controller_trees) {
    with(obj_controller_trees) {
        event_perform(ev_other, ev_room_start);
    }
}
if instance_exists(obj_controller_graytrees) {
    with(obj_controller_graytrees) {
        event_perform(ev_other, ev_room_start);
    }
}

/* move some background parts */
if instance_exists(obj_graybgshape) {
    with(obj_graybgshape) {
        x += obj_player.delta_xview;
        y += obj_player.delta_yview;
    }
}
#define Step_0
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// strange computer words

event_inherited();

var key_jump, key_hjump, key_up, key_down, key_left, key_right, move;
key_up = keyboard_check(ord('W'));
key_down = keyboard_check(ord('S'));
key_left = keyboard_check(ord('A'));
key_right = keyboard_check(ord('D'));
key_jump = keyboard_check_pressed(vk_space);
key_hjump = keyboard_check(vk_space);
move = key_right - key_left;

onground = (place_meeting(x, y + 1, obj_wall));

var computer_left, computer_down, computer_up, computer_right;
computer_left = keyboard_check_pressed(vk_left) || keyboard_check_pressed(ord('H'));
computer_down = keyboard_check_pressed(vk_down) || keyboard_check_pressed(ord('J'));
computer_up = keyboard_check_pressed(vk_up) || keyboard_check_pressed(ord('K'));
computer_right = keyboard_check_pressed(vk_right) || keyboard_check_pressed(ord('L'));

/* physics constants */
var movespeed, gravspeed, jumpspeed, maxjhold;
movespeed = 2 + burning * 2;
gravspeed = 0.2;
jumpspeed = -4;
maxjhold = 8;

/* jumping */
if (onground) {
    jhold = 0;
    if (key_jump) {
        ysp = jumpspeed;
        jhold = 1;
        sound_volume(sound_play("snd_jump"), 0.7);
    }
} else {
    if (key_hjump && jhold > 0 && jhold < maxjhold) {
        ysp = jumpspeed;
        jhold += 1;
    } else {
        jhold = 0;
    }
}

xsp = move * movespeed; /* horizontal movement */
running = (move != 0); /* uhh */
if ((!wet) && (!casting)) ysp += gravspeed; /* gravity */
if (telekinesis) ysp = 0; /* un gravity */
anim_frame = (anim_frame + 0.2) mod 2; /* character animation */
computering = collision_rectangle(x - 6, y - 6, x + 5, y + 5, obj_computer, 0, 0); /* computer */

/* climbing */
if place_meeting(x, y, obj_vine) {
    if (key_up) climbing = 1;
} else {
    climbing = 0;
}
if (climbing) {
    xsp = move * movespeed div 2;
    ysp = (key_down - key_up) * movespeed div 2;
    if (!casting && ((xsp == 0) && (ysp == 0))) anim_frame -= 0.2;
}

/* break out of self-inflicted spells */
if ((move != 0) && frozen) {
    frozen = 0;
    effect_iceshards(x, y);
    if instance_exists(obj_eye) {
        obj_eye.lasered = 0;
    }
}
if (key_jump && wet) {
    wet = 0;
    effect_bubblepop(x, y);
}

/* horizontal wall collisions */
if place_meeting(x + xsp, y, obj_wall) {
    while !place_meeting(x + sign(xsp), y, obj_wall) {
        x += sign(xsp);
    }
    xsp = 0;
}
x += round(xsp);

/* change facing for sprite */
if (move !=0) {
    facing = move;
}

/* vertical wall collisions */
if place_meeting(x, y + ysp, obj_wall) {
    while !place_meeting(x, y + sign(ysp), obj_wall) {
        y += sign(ysp);
    }
    ysp = 0;
}
if (!casting) y += round(ysp);

/* spellcasting */
var oldcasting;
oldcasting = casting;
casting = mouse_check_button(mb_left);
if (casting) {
    /* drawing spellpath */
    x = xprevious;
    y = yprevious;
    xsp = 0;
    /* add new points to the spellpath */
    if (((mouse_x >= view_xview[0]) && (mouse_x < view_xview[0] + view_wview[0])) && ((mouse_y >= view_yview[0]) && (mouse_y < view_yview[0] + view_hview[0]))) {
        if (oldcasting) {
            var prev, sx, sy;
            prev = ds_list_size(spellpath_x) - 1; /* both ds lists *should* be the same size */
            sx = ds_list_find_value(spellpath_x, prev) - mouse_x;
            sy = ds_list_find_value(spellpath_y, prev) - mouse_y;
            /* only add new point to path if more than 8 pixels away from previous point */
            if (sx * sx + sy * sy > 64 ) {
                ds_list_add(spellpath_x, mouse_x);
                ds_list_add(spellpath_y, mouse_y);
                spellpath_length += sqrt(sx * sx + sy * sy);
            }
        } else {
            ds_list_add(spellpath_x, mouse_x);
            ds_list_add(spellpath_y, mouse_y);
            spellpath_length = 0;
        }
    }
} else {
    if (oldcasting) {
        var col, i, j, top_index, spell_blocked;
        top_index = ds_list_size(cards) - 1;
        spell_blocked = 0;

        /* check for overlap with anti-spell fields */
        for (i = 0; i < ds_list_size(spellpath_x) - 1; i += 1) {
            if collision_line(ds_list_find_value(spellpath_x, i), ds_list_find_value(spellpath_y, i), ds_list_find_value(spellpath_x, i + 1), ds_list_find_value(spellpath_y, i + 1), obj_nospellfield, 0, 0) {
                spell_blocked = 1;
                break;
            }
        }

        /* check if spell is too long */
        if (spellpath_length > max_spellpath_length) {
            spell_blocked = 1;
        }

        /* cast the spell */
        cast_success = 0;
        if (!spell_blocked) {
            switch ds_list_find_value(cards, top_index) {
                case 0: break;
                case 1: cast_fire(); break;
                case 2: cast_electro(); break;
                case 3: cast_plant(); break;
                case 4: cast_ice(); break;
                case 5: cast_water(); break;
                case 6: cast_telekinesis(); break;
            }
        } else {
            sound_volume(sound_play("snd_spellfail"), 7);
        }

        /* create sparkles */
        if (cast_success) {
            if ds_list_empty(cards) {
                col = c_gray;
            } else {
                col = colors[ds_list_find_value(cards, top_index)];
            }
            /* no */
            if (wet) ysp = 0;
        } else {
            if (spell_blocked) {
                col = c_maroon;
            } else {
                col = c_gray;
            }
        }

        for (i = 0; i < ds_list_size(spellpath_x); i += 1) {
            var sparkle;
            sparkle = instance_create(ds_list_find_value(spellpath_x, i), ds_list_find_value(spellpath_y, i), obj_sparkle);
            sparkle.image_blend = col;
        }

        /* pop top card off of deck */
        if (!ds_list_empty(cards) && cast_success) {
            if (!computering) {
                for (i = 0; i < 24; i += 8) {
                    for (j = 0; j < 32; j += 8) {
                        var sparkle;
                        sparkle = instance_create(12 + top_index * 8 + i, 12 + HUD_YOFFSET + j, obj_sparkle);
                        sparkle.image_blend = col;
                    }
                }
            }
            ds_list_delete(cards, top_index);
        }

        /* clear spellpath */
        ds_list_clear(spellpath_x);
        ds_list_clear(spellpath_y);
    }
}

/* using a computer */
if (computering) {
    if (computer_down || computer_up) sound_volume(sound_play("snd_computerclick"), 4);
    computer_selection = computer_selection + computer_down - computer_up;
    if (computer_selection < 0) computer_selection = 6;
    if (computer_selection > 6) computer_selection = 0;
    if ((computer_left) && !ds_list_empty(cards)) {
        ds_list_delete(cards, ds_list_size(cards) - 1);
        effect_star(computering.x, computering.y, 64, c_gray);
        sound_pitch(sound_play("snd_removecard"), 1 + ds_list_size(cards) * 0.1);
    }
    if (computer_right) {
        if (computer_selection == 0) {
            if !ds_list_empty(cards) {
                ds_list_delete(cards, ds_list_size(cards) - 1);
                effect_star(computering.x, computering.y, 64, c_gray);
                sound_pitch(sound_play("snd_removecard"), 1 + ds_list_size(cards) * 0.1);
            }
        } else {
            if ((ds_list_size(cards) < computering.max_cards) && (computering.stock[computer_selection])) {
                ds_list_add(cards, computer_selection);
                effect_star(computering.x, computering.y, 64, colors[computer_selection]);
                sound_pitch(sound_play("snd_addcard"), 0.9 + ds_list_size(cards) * 0.1);
            }
        }
    }
}

/* super telekinesis wall fix */
if (!telekinesis) {
    if place_meeting(x, y, obj_wall) {
        effect_star(x, y, 16, c_fuchsia);
        x = x_before_telekinesis;
        y = y_before_telekinesis;
        repeat (12) {
            var sparkle;
            sparkle = instance_create(x + random_range(-8, 8), y + random_range(-8, 8), obj_sparkle);
            sparkle.image_blend = c_fuchsia;
        }
    }
    x_before_telekinesis = x;
    y_before_telekinesis = y;
}
#define Collision_obj_portal
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// congratulis
transition_kind = 5;
room_goto_next();
#define Other_4
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// mystery
/*
var i;
for (i = 0; i < instance_count; i += 1) {
    var obj;
    obj = instance_id[i];
    if object_is_ancestor(obj, par_loadable) {
        ds_list_add(loadlist_x, obj.x);
        ds_list_add(loadlist_y, obj.y);
        ds_list_add(loadlist_o, obj.object_index);

        if !(((obj.x >= view_xview[0]) && (obj.x < view_xview[0] + view_wview[0])) && ((obj.y >= view_yview[0]) && (obj.y < view_yview[0] + view_hview[0]))) {
            with(obj) {
                instance_destroy();
            }
        }
    }
}
*/
#define Other_5
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// bye bye ds list
ds_list_destroy(cards);
ds_list_destroy(spellpath_x);
ds_list_destroy(spellpath_y);
font_delete(computer_font);
/*
ds_list_destroy(loadlist_x);
ds_list_destroy(loadlist_y);
ds_list_destroy(loadlist_o);
*/
#define Other_40
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// scroll the screen the scroll
delta_xview = 0;
delta_yview = 0;
if (x <= view_xview[0]) {
    view_xview[0] -= view_wview[0];
    delta_xview -= view_wview[0];
}
if (x >= view_xview[0] + view_wview[0]) {
    view_xview[0] += view_wview[0];
    delta_xview += view_wview[0];
}
if (y <= view_yview[0]) {
    view_yview[0] -= view_hview[0];
    delta_yview -= view_hview[0];
}
if (y >= view_yview[0] + view_hview[0]) {
    view_yview[0] += view_hview[0];
    delta_yview += view_hview[0];
}

/* we are not doing this, i have decided
var i;
for (i = 0; i < ds_list_size(loadlist_x); i += 1) {
    if (
        ((ds_list_find_value(loadlist_x, i) >= view_xview[0]) && (ds_list_find_value(loadlist_x, i) < view_xview[0] + view_wview[0])) &&
        ((ds_list_find_value(loadlist_y, i) >= view_yview[0]) && (ds_list_find_value(loadlist_y, i) < view_yview[0] + view_hview[0]))
    ) {
        instance_create(ds_list_find_value(loadlist_x, i), ds_list_find_value(loadlist_y, i), ds_list_find_value(loadlist_o, i));
    }
}
*/

/* we are doing this, however */
event_perform(ev_alarm, 0);
#define Draw_0
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// next gen graphics
var i, j, col, cursor_x, cursor_y, playersprite;

/* draw cards */
col = c_gray;
for (i = 0; i < ds_list_size(cards); i += 1) {
    draw_sprite(spr_card, ds_list_find_value(cards, i), 8 + i * 8, HUD_YOFFSET + 8);
    col = colors[ds_list_find_value(cards, i)];
}

/* draw keys */
for (i = 0; i < keys; i += 1) {
    draw_sprite(spr_keyicon, 0, view_wview[1] - 4 - i * 4, HUD_YOFFSET + view_hview[1] - 8);
}

/* intelligently draw computer on top of the already-drawn cards and keys */
if ((computering) && instance_exists(computering)) {
    draw_set_halign(fa_left);
    draw_set_valign(fa_top);
    draw_set_font(computer_font);
    var computer_color;
    computer_color = c_orange;
    if (computering.burning) computer_color = c_red;
    /* if (computering.shocked) computer_color = c_yellow; */
    if (computering.frozen) computer_color = c_aqua;
    if (computering.wet) computer_color = c_blue;

    /* background */
    draw_set_color(computer_color);
    draw_rectangle(view_xview[1], view_yview[1], view_xview[1] + view_wview[1], view_yview[1] + 6, 0);
    draw_set_color(c_black);
    draw_rectangle(view_xview[1], view_yview[1] + 6, view_xview[1] + view_wview[1], view_yview[1] + view_hview[1], 0);
    draw_text(view_xview[1], view_yview[1], "DELICIOUS BONE FLAPS VER 13 37");

    /* arrow keys */
    var key;
    key = keyboard_check(vk_left) || keyboard_check(ord('H'));
    draw_sprite_ext(spr_arrowkeys, 0 + key, view_xview[1] + 108, view_yview[1] + view_hview[1] - 12, 1, 1, 0, computer_color, 1);
    key = keyboard_check(vk_down) || keyboard_check(ord('J'));
    draw_sprite_ext(spr_arrowkeys, 2 + key, view_xview[1] + 114, view_yview[1] + view_hview[1] - 12, 1, 1, 0, computer_color, 1);
    key = keyboard_check(vk_up) || keyboard_check(ord('K'));
    draw_sprite_ext(spr_arrowkeys, 4 + key, view_xview[1] + 120, view_yview[1] + view_hview[1] - 12, 1, 1, 0, computer_color, 1);
    key = keyboard_check(vk_right) || keyboard_check(ord('L'));
    draw_sprite_ext(spr_arrowkeys, 6 + key, view_xview[1] + 126, view_yview[1] + view_hview[1] - 12, 1, 1, 0, computer_color, 1);

    /* card listings */
    for (i = 0; i <= 6; i += 1) {
        var yoffset, cardcount, cardname;
        yoffset = 6 * i + 6 + view_yview[1];
        cardcount = 0;
        cardname = "NO STOCK   "
        draw_set_color(computer_color);
        if (i == computer_selection) {
            draw_rectangle(view_xview[1], yoffset, view_xview[1] + 107, yoffset + 5, 0);
            draw_set_color(c_black);
        }
        if (computering.stock[i] == 1) cardname = cardnames[i];
        for (j = 0; j < ds_list_size(cards); j += 1) {
            if (ds_list_find_value(cards, j) == i) cardcount += 1;
        }
        draw_text(view_xview[1], yoffset, string(i) + " " + cardname + " X " + string(cardcount));
    }
    draw_set_color(computer_color);

    /* card stack */
    var cardstring;
    cardstring = "";
    for (i = 0; i < ds_list_size(cards); i += 1) {
        cardstring += string(ds_list_find_value(cards, i));
    }
    draw_text(view_xview[1] + 108, view_yview[1] + 6, "STACK " + string(cardstring));

    /* card counts */
    if (ds_list_size(cards) >= computering.max_cards) {
        draw_rectangle(view_xview[1] + 108, view_yview[1] + 12, view_xview[1] + 179, view_yview[1] + 23, 0);
        draw_set_color(c_black);
    }
    draw_text(view_xview[1] + 108, view_yview[1] + 12, "NUM CARDS " + string(ds_list_size(cards)));
    draw_text(view_xview[1] + 108, view_yview[1] + 18, "MAX CARDS " + string(computering.max_cards));
}

/* draw player */
playersprite = spr_player_idle;
if (running) playersprite = spr_player_run;
if (climbing) playersprite = spr_player_climb;
if (casting) playersprite = spr_player_cast;
draw_sprite_ext(playersprite, anim_frame, x, y, facing, 1, 0, c_white, 1);

event_inherited();

/* draw spellpath */
for (i = 0; i < ds_list_size(spellpath_x); i += 1) {
    draw_sprite_ext(spr_star, 0, ds_list_find_value(spellpath_x, i), ds_list_find_value(spellpath_y, i), 1, 1, 0, col, 1);
}

/* draw spell length indicator */
if (casting) {
    if (spellpath_length > max_spellpath_length) {
        col = c_maroon;
    }
    var meter_fullness;
    meter_fullness = min((spellpath_length / max_spellpath_length) * 15, 15);
    draw_sprite(spr_meter, 0, x, y + 12);
    draw_set_color(col);
    if (meter_fullness > 0) draw_rectangle(x - 8, y + 11, x - 8 + meter_fullness, y + 12, 0);
}

/* draw cursor */
cursor_x = mouse_x;
cursor_y = mouse_y;
if (mouse_y < view_yview[0]) {
    cursor_x += view_xview[0];
    cursor_y += view_yview[0] - view_hview[1] - HUD_YOFFSET;
}
draw_sprite_ext(spr_cursor, casting, cursor_x, cursor_y, 1, 1, 0, col, 1);
#define KeyPress_82
/*"/*'/**//* YYD ACTION
lib_id=1
action_id=603
applies_to=self
*/
/// AAAAAAAAaaaaaaa
if debug_mode repeat 12 ds_list_add(cards, irandom_range(1, 6));
